"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSharedMappingsPlugin = createSharedMappingsPlugin;
const tslib_1 = require("tslib");
const path = tslib_1.__importStar(require("path"));
function createSharedMappingsPlugin(mappedPaths) {
    return {
        name: 'custom',
        setup(build) {
            build.onResolve({ filter: /^[.]/ }, (args) => tslib_1.__awaiter(this, void 0, void 0, function* () {
                let mappedPath = null;
                let isSelf = false;
                if (args.kind === 'import-statement') {
                    const importPath = path.join(args.resolveDir, args.path);
                    mappedPath = mappedPaths.find((p) => importPath.startsWith(path.dirname(p.path)));
                }
                if (mappedPath) {
                    isSelf = args.importer.startsWith(path.dirname(mappedPath.path));
                }
                if (mappedPath && !isSelf) {
                    return {
                        path: mappedPath.key,
                        external: true,
                    };
                }
                return {};
            }));
        },
    };
}
//# sourceMappingURL=shared-mappings-plugin.js.map